%define pkg_name skynet
%define pkg_parent rhscon-core

Name: rhscon-agent
Version: 0.0.18
Release: 1%{?dist}
BuildArch: noarch
Summary: SKYRING Node Event Agent
Source0: %{pkg_name}-%{version}.tar.gz
License: ASL 2.0
Group: Development/Libraries
Url: https://github.com/skyrings/skynet

BuildRequires: python-devel
BuildRequires: python-setuptools

Requires: collectd
Requires: collectd-ping
Requires: python-cpopen
Requires: python-setuptools
Requires: salt-minion >= 2015.5.5
Requires: storaged
Requires: storaged-lvm2
Requires: socat
Requires: bc
Requires: salt-selinux
Requires: %{pkg_parent}-selinux

%description
SKYNET is the event agent for SKYRING. Each storage node managed
by SKYRING will have this agent running on them. It is a daemon which listens
to DBUS signals, filters it, processes it and pushes the filtered signals to
SKYRING using salt-stack event framework. Currently this daemon has
capability to send basic storage, process and network related events.

%prep
%setup -n %{pkg_name}-%{version}

%build
python setup.py build

%install
python setup.py install --single-version-externally-managed -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES
install -Dm 0644 conf/skynet_logrotate.conf.sample $RPM_BUILD_ROOT/etc/logrotate.d/rhscon-agent
install -Dm 0644 conf/skynet-sudoers.conf $RPM_BUILD_ROOT/%{_sysconfdir}/sudoers.d/skynet-sudoers
install -Dm 0644 src/skynetd/conf/skynet.conf.sample $RPM_BUILD_ROOT/etc/skynet/skynet.conf
install -Dm 0644 src/skynetd/conf/skynet-log.conf.sample $RPM_BUILD_ROOT/etc/skynet/skynet-log.conf
install -Dm 0644 skynetd.service $RPM_BUILD_ROOT/usr/lib/systemd/system/skynetd.service
install -D src/collectd_scripts/handle_collectd_notification.py $RPM_BUILD_ROOT/usr/lib64/collectd/handle_collectd_notification.py
install -Dm 0755 src/collectd_scripts/ifspeed.sh $RPM_BUILD_ROOT/usr/lib64/collectd/ifspeed.sh
gzip skynetd.8
install -Dm 0644 skynetd.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/skynetd.8.gz
chmod a+x $RPM_BUILD_ROOT%{python_sitelib}/skynetd/skynetd.py

%pre
if [ `grep -c ^skyring-user /etc/passwd` = "0" ]; then
    /usr/sbin/useradd skyring-user -g wheel
fi


%post
dbus-send --system --print-reply --type=method_call --dest=org.storaged.Storaged /org/storaged/Storaged/Manager org.storaged.Storaged.Manager.EnableModules boolean:true
/bin/systemctl enable skynetd.service >/dev/null 2>&1 || :
/bin/systemctl restart skynetd.service >/dev/null 2>&1 || :

%files -f INSTALLED_FILES
%{_sysconfdir}/skynet/
%{_sysconfdir}/logrotate.d/rhscon-agent
%{_sysconfdir}/sudoers.d/skynet-sudoers
%config(noreplace) %{_sysconfdir}/skynet/skynet.conf
%config(noreplace) %{_sysconfdir}/skynet/skynet-log.conf
%{_usr}/lib/systemd/system/skynetd.service
%{_usr}/lib64/collectd/
%doc README.md
%{_mandir}/man8/skynetd.8*

%changelog
* Sat Aug 06 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.18-1
- Changes
  - Corrected n/w utilization calculations

* Fri Aug 05 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.17-1
- Changes
  - Push only the events that are handled by skyring

* Wed Jul 20 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.16-1
- Changes
  - Push n/w utilization to graphite only if bandwidth is available

* Wed Jul 13 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.15-1
- Changes
  - Added sample sudoers file for skyring user

* Fri Jul 08 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.14-1
- Changes
  - Corrected man page title
  - Cleanup of spec file

* Wed Jul 06 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.13-4
- Changes
  - Corrected an issue with selinux package name

* Wed Jul 06 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.13-3
- Changes
  - Corrected an issue with selinux package name

* Tue Jul 05 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.13-2
- Changes
  - Corrected selinux package name reference

* Fri Jun 24 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.13-1
- Changes
  - Fixed dbus error on device add or device remove

* Sat Jun 18 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.12-1
- Changes
  - Added selinux dependency

* Tue Jun 14 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.11-1
- Changes
  - Enable storaged on start of skynetd service

* Tue Jun 07 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.10-1
- Changes
  - corrected readme file - releases must be done on the "master" branch
  - Only skyring-user !requiretty

* Fri May 27 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.9-1
- Changes
  - Added dependency on package "bc"

* Fri May 20 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.8-1
- Changes
  - Corrected versioning mechanism and added options to bump version

* Tue May 17 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.7-1
- Changes
  - Enabled logrotate for project

* Fri May 06 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-1
- Changes
  - Added network used and bandwidth monitoring

* Fri Apr 29 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.5-1
- Changes
  - Added dependency on socat
  - Added network utilization plugin

* Fri Apr 22 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.4-1
- Changes
  - fixed rpmlint errors
  - notification script changes
  - requiretty disabled
  - made skynetd service a proper systemd service

* Fri Mar 11 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.3-4
- Build rhscon-agent v0.0.3-4
- Changes
  - collectd-ping dependency
  - Fixes in collectd event notifier script

* Mon Feb 29 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.3-3
- Build rhscon-agent v0.0.3-3

* Wed Feb 24 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.3-2
- Added python-cpopen dependency

* Thu Jan 28 2016 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.3-1
- Removed alpha-1 from release

* Mon Jan 11 2016 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.3-0.2.alpha1
- Added missing collectd_influxdb python module

* Tue Jan 05 2016 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.3-0.1.alpha1
- Build alpha1 - v0.0.3-0.1.alpha1

* Thu Dec 31 2015 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.2-0.1.alpha1
- Build alpha1 - v0.0.2-0.1.alpha1

* Wed Dec 23 2015 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.1-2
- Renamed pre-defined macros

* Thu Dec 03 2015 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 0.0.1-1
- Initial build.
